/**
 * @file	FontObjects.cpp
 * @brief	tHg̃IuWFNgǗNXłB
 * @author	Shinji Watanabe
 * @date	2009/03/16
 */

#pragma once

class CFontObjects
{
public:
	// RXgN^
	CFontObjects();
	virtual ~CFontObjects();

	bool CreateAll( HDC hDC );
	

	// tHg쐬邽߂̃[`
	bool SetRuler(HDC hDC,int nRulerHeight);

	inline HFONT UseFont(HDC hDC,FontMode nMode)
	{
		return (HFONT)SelectObject(hDC,m_hFont[nMode]);
	}
	inline HFONT UseKanjiFont(HDC hDC)
	{
		return (HFONT)SelectObject(hDC,GetKanjiFont());
	}
	inline HFONT GetKanjiFont()
	{
		return m_hFont[FFM_SHIFTJIS_CHARSET];
	}
	inline HFONT UseRulerFont(HDC hDC)
	{
		return (HFONT)SelectObject(hDC,m_hRulerFont);
	}

	// 擾
	inline int GetWidth()		const {return m_nFontWidth;}
	inline int GetHeight()		const { return m_nFontHeight; }
	inline int GetRulerHeight() const { return m_nRulerHeight; }
	inline int GetFontSize()	const { return m_nFontPoint; }
	
	/*ݒ*/
	void SetFontSize( int nPoint, HDC hDC )
	{
		m_nFontPoint = nPoint;
		CreateAll( hDC );
	}
	bool SetFontFace(int nType,const wchar_t *pFontFace,HDC hDC);

	// tHg̋ by inovia
	void SetForceFont( int flag );
	// ` by inovia
	void SetSpeedDraw( int flag );

private:
	bool CreateFontObject(int nType,HDC hDC);
	HFONT GetFontHandle(const wchar_t *szFontName,int nHeight,bool bBold,int nCharSets);
	void SetFontPixels(HDC hDC);
	int GetMulDiv(int nNumber,int nNumerator,int nDenominator);
	inline int HeightFromPoint(HDC hDC,int nPoint){
		return -GetMulDiv(nPoint, GetDeviceCaps(hDC, LOGPIXELSY), 72);
	}
	
private:
	enum fixed_num
	{
#ifdef UNDER_CE
		FONTNORMAL_DEFAULT = 9,
#else	/*UNDER_CE*/
		FONTNORMAL_DEFAULT = 11,
#endif	/*UNDER_CE*/
	}	/*enum fixed_num*/;
	
	HFONT m_hFont[FFM_NUM_FONTS];				//!< tHgXg
	HFONT m_hRulerFont;							//!< [[̃tHg
	std::wstring m_strFace[FFM_NUM_FONTS];		//!< tHg̖O
	static const int m_nCharSets[FFM_NUM_FONTS];
	int m_fnWeight;								//!< {[ĥ̎̑
	int m_nFontPoint;							//!< tHg̃TCY(|Cg)
	int m_nFontHeight;							//!< CtHg̍(sNZ)
	int m_nFontWidth;							//!< CtHg̕(sNZ)
	int m_nRulerHeight;							//!< [[tHg̍
	int m_fForceFont;							//!< tHg邩H by inovia
};

/*[EOF]*/
