/**
 * @file FootyLineClick.cpp
 * @brief NbJun̏s܂B
 * @author Shinji Watanabe
 * @version 1.0
 * @date Jan.08.2008
 */

#include "FootyLine.h"

/**
 * CFootyLine::FindURL
 * @brief URL܂B
 * @param start [in] Jnʒu
 * @param pBegin [out] Jnʒu
 * @param pEnd [out] Iʒu
 */
bool CFootyLine::FindURL(size_t start,size_t *pBegin,size_t *pEnd)
{
	// 錾
	const wchar_t *pLineData = GetLineData() + start;
	size_t nTextLen = GetLineLength();
	size_t len = -1;
	// Jn
	for (size_t i=start;i<nTextLen;i++,pLineData++)
	{
		// r
		if (5 <= nTextLen-i && IsMatched(pLineData,L"http:",5))len=5;
		if (6 <= nTextLen-i && IsMatched(pLineData,L"https:",6))len=6;
		if (4 <= nTextLen-i && IsMatched(pLineData,L"ftp:",4))len=4;
		
		// vƂ
		if (len!=-1)
		{
			*pBegin = i;
			for (pLineData+=len,i+=len;i<nTextLen;i++,pLineData++)
			{
				if (!IsURLChar(*pLineData))	// URL̓̕K`FbN
				{
					*pEnd = i;
					return true;
				}
			}
			*pEnd = nTextLen;
			return true;
		}
	}
	*pBegin = *pEnd = -1;
	return false;
}

/**
 * CFootyLine::FindMail
 * @brief [AhX܂B
 * @param start [in] Jnʒu
 * @param pBegin [out] Jnʒu
 * @param pEnd [out] Iʒu
 */
bool CFootyLine::FindMail(size_t start,size_t *pBegin,size_t *pEnd)
{
	// 錾
	int work=-1;										//!< op
	bool bDotFound;										//!< hbg
	size_t i,j;
	const wchar_t *pLineData = GetLineData() + start;	//!< p
	const wchar_t *pWork;
	size_t nTextLen = GetLineLength();

	// 
	for (i = start;i<nTextLen;i++,pLineData++)			// ŌォO܂
	{
		bDotFound = false;
		if (*pLineData == L'@')							// }[N
		{
			if (i == 0)continue;						// ȑOꍇ͎
			for (j=i-1,pWork=pLineData-1;;pWork--,j--)	// ȑOĂ
			{
				if (j == -1)
				{
					*pBegin=0;
					break;
				}
				if (!IsMailChar(*pWork))				// [ƂĕsK؂ȏꍇ
				{
					if (j == i - 1)goto NextI;			// }[NȑOɂȂ玟
					*pBegin = j + 1;
					break;
				}
			}
			for (j=i+1,pWork=pLineData+1;;pWork++,j++)	// }[Nȍ~
			{
				if (j == nTextLen)
				{
					*pEnd = nTextLen;
					if (bDotFound)
						return true;
					goto NextI;
				}
				if (!IsMailChar(*pWork))
				{
					if (i == j+1)goto NextI;			// ȍ~̕񂪌Ȃ
					*pEnd = j;
					if (bDotFound)
						return true;
					goto NextI;
				}
				if (*pWork == L'.')						// @ȍ~.
					bDotFound = true;
			}
		}
NextI:;
	}
	*pBegin = *pEnd = -1;
	return false;
}

/**
 * CFootyLine::IsMailChar
 * @brief [AhX̕ƂēK
 * @param c ׂ镶
 * @return K؂ȏꍇtrueԂ܂B
 */
bool CFootyLine::IsMailChar(wchar_t c)
{
	if (c==L'~'  || (97 <=c && c <= 122) || // a`z
		c==L'_'  || (65 <=c && c <= 90)  || // ?,A`Z
		c==L'\\' || (45 <=c && c <= 58)  || // AsIhAnCtAXbVAR
		c==L'='  || (36 <=c && c <= 38)  ||
		c==L'&'  || c==L'%' || c==L'#' || c==L'+')
		return true;
	else
		return false;
}

/**
 * CFootyLine::IsURLChar
 * @brief URL̕ƂēKׂ̂̂܂B
 * @param c ׂ镶
 * @return K؂ȏꍇtrueԂ܂B
 */
bool CFootyLine::IsURLChar(wchar_t c)
{
	if (c==L'~'  || (97 <=c && c <= 122) ||
		c==L'_'  || (65 <=c && c <= 90)  ||
		c==L'!'  || (44 <=c && c <= 59)  ||
		c==L'='  || (36 <=c && c <= 38)  ||
		c==L'*'  || c==L'?' || c==L'#')
		return true;
	else
		return false;
}

/*[EOF]*/
